/***************************************************************************
 *   Copyright (C) 2005 by Peter Müller   *
 *   pmueller@cs.tu-berlin.de   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef EFFECT_H
#define EFFECT_H

#include "cometen_math.h"

/**
@author Peter Müller
*/

class Effect {
public:
	Effect(const Vec3 & p = Vec3::ZERO) 
		:
		pos(p)
	{}
		
	virtual ~Effect() {}
	
	virtual void process(float time) = 0;
	virtual void render(const Vec3 & viewpoint) = 0;
	virtual bool done() = 0;
	virtual void stop() = 0;

	virtual const Vec3 & getPos() {
		return pos;
	}
	virtual void setPos(const Vec3 & _pos) {
		pos = _pos;
	}
	
	
protected: 
	Vec3 pos;
};

#endif
