/***************************************************************************
 *   Copyright (C) 2005 by Peter Müller   *
 *   pmueller@cs.tu-berlin.de   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "vec.h"
#include "cometen_math.h"

#include <cmath>

const Vec2 Vec2::ZERO(0.0f, 0.0f);
const Vec2 Vec2::X(1.0f, 0.0f);
const Vec2 Vec2::Y(0.0f, 1.0f);

Vec3 Vec3::randomUnit() {
	Vec3 newvec(frand(-1.0f,1.0f), 
		frand(-1.0f,1.0f), 
		frand(-1.0f,1.0f));
	
	float l = newvec.getLength();
	if (l == 0.0f) {
		return Vec3(1.0f, 0.0f, 0.0f);
	}
	else {
		newvec /= l;	
		return newvec;
	}	
}

void Vec3::reflect(const Vec3 & normal) {
	float a = dot(normal) * 2;
	
	x = x - normal.x * a; 
	y = y - normal.y * a;
	z = z - normal.z * a;
}

const Vec3 Vec3::ZERO(0.0f, 0.0f, 0.0f);
const Vec3 Vec3::X(1.0f, 0.0f, 0.0f);
const Vec3 Vec3::Y(0.0f, 1.0f, 0.0f);
const Vec3 Vec3::Z(0.0f, 0.0f, 1.0f);


const Vec4 Vec4::ZERO(0.0f, 0.0f, 0.0f, 0.0f);
const Vec4 Vec4::X(1.0f, 0.0f, 0.0f, 0.0f);
const Vec4 Vec4::Y(0.0f, 1.0f, 0.0f, 0.0f);
const Vec4 Vec4::Z(0.0f, 0.0f, 1.0f, 0.0f);
const Vec4 Vec4::W(0.0f, 0.0f, 0.0f, 1.0f);
